/**
 * ObjectClasses.java
 *
 * File generated from the LDAStructure::ObjectClasses uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.ldap.model;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import javax.persistence.*;
import javax.xml.bind.annotation.*;

import org.jboss.seam.annotations.Name;

// End of user code

/**
 * Description of the class ObjectClasses.
 * 
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "ObjectClasses", propOrder = { "supobjectclass", "typeobjectclass", "must", "may" })
@XmlRootElement(name = "ObjectClasses")
@Entity
@Name("objectClasses")
@Table(name = "hpd_ldap_object_classes", schema = "public", uniqueConstraints = @UniqueConstraint(columnNames = "name"))
@SequenceGenerator(name = "hpd_ldap_object_classes_sequence", sequenceName = "hpd_ldap_object_classes_id_seq", allocationSize = 1)
public class ObjectClasses extends AbstractStructure implements java.io.Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(generator = "hpd_ldap_object_classes_sequence", strategy = GenerationType.SEQUENCE)
	@Column(name = "id", unique = true, nullable = false)
	@XmlTransient
	private Integer id;

	@XmlElement(name = "supobjectclass")
	@Column(name = "sup_object_class")
	public String supobjectclass;

	@XmlElement(name = "typeobjectclass")
	@Column(name = "type_object_class")
	public TypeObjectClass typeobjectclass;

	@XmlElement(name = "must")
	@ElementCollection(targetClass = String.class)
	@CollectionTable(name = "hpd_ldap_object_classes_must", joinColumns = @JoinColumn(name = "object_classes_id", referencedColumnName = "id"))
	@Column(name = "must")
	public List<String> must;

	@XmlElement(name = "may")
	@ElementCollection(targetClass = String.class)
	@CollectionTable(name = "hpd_ldap_object_classes_may", joinColumns = @JoinColumn(name = "object_classes_id", referencedColumnName = "id"))
	@Column(name = "may")
	public List<String> may;

	public ObjectClasses() {
		super();
	}

	/**
	 * Return supobjectclass.
	 * 
	 * @return supobjectclass
	 */
	public String getSupobjectclass() {
		return supobjectclass;
	}

	/**
	 * Set a value to attribute supobjectclass.
	 * 
	 * @param supobjectclass
	 *            .
	 */
	public void setSupobjectclass(String supobjectclass) {
		this.supobjectclass = supobjectclass;
	}

	/**
	 * Return typeobjectclass.
	 * 
	 * @return typeobjectclass
	 */
	public TypeObjectClass getTypeobjectclass() {
		return typeobjectclass;
	}

	/**
	 * Set a value to attribute typeobjectclass.
	 * 
	 * @param typeobjectclass
	 *            .
	 */
	public void setTypeobjectclass(TypeObjectClass typeobjectclass) {
		this.typeobjectclass = typeobjectclass;
	}

	/**
	 * Return must.
	 * 
	 * @return must
	 */
	public List<String> getMust() {
		if (must == null) {
			must = new ArrayList<String>();
		}
		Collections.sort(must);
		return must;
	}

	/**
	 * Set a value to attribute must.
	 * 
	 * @param must
	 *            .
	 */
	public void setMust(List<String> must) {
		this.must = must;
	}

	/**
	 * Add a must to the must collection.
	 * 
	 * @param must_elt
	 *            Element to add.
	 */
	public void addMust(String must_elt) {
		this.must.add(must_elt);
	}

	/**
	 * Remove a must to the must collection.
	 * 
	 * @param must_elt
	 *            Element to remove
	 */
	public void removeMust(String must_elt) {
		this.must.remove(must_elt);
	}

	/**
	 * Return may.
	 * 
	 * @return may
	 */
	public List<String> getMay() {
		if (may == null) {
			may = new ArrayList<String>();
		}
		Collections.sort(may);
		return may;
	}

	/**
	 * Set a value to attribute may.
	 * 
	 * @param may
	 *            .
	 */
	public void setMay(List<String> may) {
		this.may = may;
	}

	/**
	 * Add a may to the may collection.
	 * 
	 * @param may_elt
	 *            Element to add.
	 */
	public void addMay(String may_elt) {
		this.may.add(may_elt);
	}

	/**
	 * Remove a may to the may collection.
	 * 
	 * @param may_elt
	 *            Element to remove
	 */
	public void removeMay(String may_elt) {
		this.may.remove(may_elt);
	}

	public static ObjectClasses getObjectClassByName(String inName) {
		if ((inName != null) && !inName.isEmpty()) {
			ObjectClassesQuery query = new ObjectClassesQuery();
			query.name().eq(inName);
			return query.getUniqueResult();
		} else {
			return null;
		}
	}

	public Integer getId() {
		return id;
	}
}